#!/usr/local/bin/php -q
<?php

set_time_limit(0);

require_once("/usr/lib64/adodb/adodb.inc.php");
require_once("../config.php");
require_once("../xmllib.php");


// defaults...

define('MAXLINE', 1024);        // how much to read from a socket at a time
define('LISTENQ', 10);          // listening queue
define('PORT', 43);          // the default port to run on
define('FD_SETSIZE', 5);        // file descriptor set size (max number of concurrent clients)...


// for kill the biatch...

function killDaemon() {
    global $listenfd, $client;

    socket_close($listenfd);
    $msg = "Daemon going down!\n";
    for ($i = 0; $i < FD_SETSIZE; $i++) {
        if ($client[$i] != null) {
            socket_write($client[$i], $msg, strlen($msg));
            socket_close($client[$i]);
        }
    }

    print "Shutting down the daemon\n";
    exit;
}


// whenever a client disconnects...

function closeClient($i) {
    global $client, $remote_host, $remote_port;

    print "closing client[$i] ({$remote_host[$i]}:{$remote_port[$i]})\n";

    socket_close($client[$i]);
    $client[$i] = null;
    unset($remote_host[$i]);
    unset($remote_port[$i]);
}


// set up the file descriptors and sockets...

// $listenfd only listens for a connection, it doesn't handle anything
// but initial connections, after which the $client array takes over...

$listenfd = socket_create(AF_INET, SOCK_STREAM, 0);
if ($listenfd)
    print "Listening on port " . PORT . "\n";
else
    die("AIEE -- socket died!\n");

socket_setopt($listenfd, SOL_SOCKET, SO_REUSEADDR, 1);
if (!socket_bind($listenfd, "0.0.0.0", PORT)) {
    socket_close($listenfd);
    die("AIEE -- Couldn't bind!\n");
}
socket_listen($listenfd, LISTENQ);


// set up our clients. After listenfd receives a connection,
// the connection is handed off to a $client[]. $maxi is the
// set to the highest client being used, which is somewhat
// unnecessary, but it saves us from checking each and every client
// if only, say, the first two are being used.

$maxi = -1;
for ($i = 0; $i < FD_SETSIZE; $i++) {
    $client[$i] = null;
}


// the main loop.

while (1) {
    $rfds[0] = $listenfd;

    for ($i = 0; $i < FD_SETSIZE; $i++) {
        if ($client[$i] != null)
            $rfds[$i + 1] = $client[$i];
    }


    // block indefinitely until we receive a connection...

    $nready = socket_select($rfds, $null, $null, null);


    // if we have a new connection, stick it in the $client array,

    if (in_array($listenfd, $rfds)) {
        print "listenfd heard something, setting up new client\n";

        for ($i = 0; $i < FD_SETSIZE; $i++) {
            if ($client[$i] == null) {
                $client[$i] = socket_accept($listenfd);
                socket_setopt($client[$i], SOL_SOCKET, SO_REUSEADDR, 1);
                socket_getpeername($client[$i], $remote_host[$i], $remote_port[$i]);
                print "Accepted {$remote_host[$i]}:{$remote_port[$i]} as client[$i]\n";
                break;
            }

            if ($i == FD_SETSIZE - 1) {
                trigger_error("too many clients", E_USER_ERROR);
                exit;
            }
        }
        if ($i > $maxi)
            $maxi = $i;

        if (--$nready <= 0)
            continue;
    }


    // check the clients for incoming data.

    for ($i = 0; $i <= $maxi; $i++) {
        if ($client[$i] == null)
            continue;

        if (in_array($client[$i], $rfds)) {
            $n = trim(socket_read($client[$i], MAXLINE));

            if (!$n) {
                closeClient($i);
            }
            else {
                // if a client has sent some data, do one of these:

                if ($n == "/killme") {
                    killDaemon();
                }
                else if ($n == "/quit") {
                    closeClient($i);
                }
                else {
                    // print something on the server, then echo the incoming
                    // data to all of the clients in the $client array.

                    print "From {$remote_host[$i]}:{$remote_port[$i]}, client[$i]: $n\n";
                    socket_write($client[$i], "From client[$i]: $n\r\n");
                    $test=test();
                    socket_write($client[$i], "$test\r\n");

                    closeClient($i);
                    /*
                       for ($j = 0; $j <= $maxi; $j++)
                       {
                       if ($client[$j] != null)
                       socket_write($client[$j], "From client[$i]: $n\r\n");
                       }
                     */
                }
            }

            if  (--$nready <= 0)
                break;
        }
    }
}

function test() {
    $ds = &ADONewConnection(DBF_TYPE);
    $ds->debug = DBF_DEBUG;
    if ($ds-> Connect(DBF_HOST, DBF_USER, DBF_PASSWORD, DBF_NAME) != false) {
        $ds->SetFetchMode(ADODB_FETCH_ASSOC);
        $output = genSWIP($ds, "1.1.1.1", "2.2.2.2", 1, "Test descrip", "whois.xsl");
        return $output;
        $ds->Close();
    }
}



// function to generate swip entry - returns a string with swip
// which can then be displayed/emailed etc
function genSWIP($ds, $start, $end, $cust, $descrip, $filename) {

   global $ntnameopt;

   $result1=$ds->Execute("SELECT *
                         FROM customer, custinfo
                         WHERE customer.customer = custinfo.customer and
                         customer.customer=25");
   // should only be one row here, none if SWIP turned off during creation
   // of customer
   $row1=$result1->FetchRow();

   $result2=$ds->Execute("SELECT hname, ipaddr
                         FROM revdns
                         WHERE customer=25
                         ORDER BY horder");

   $fields=array();
   $fields["ntsnum"]=$start;
   $fields["ntenum"]=$end;
   $fields=array_merge($fields, $row1);

   // use subnet description field? then only a-z, 0-9 max 21 chars allowed
   if ($ntnameopt and preg_match("/^[A-Za-z0-9\-]{1,21}$/", $descrip)) {
      $ntname=$descrip;
   }
   else {
      $ntname=MAINTAINERID."-".str_replace(".", "-", $start);
   }
   $fields["ntname"]=$ntname;
   $fields["maint"]=MAINTAINERID;

   $row2 = $result2->FetchRow();
   $fields["hname1"]=$row2["hname"];
   $fields["ipaddr1"]=$row2["ipaddr"];

   $row2 = $result2->FetchRow();
   $fields["hname2"]=$row2["hname"];
   $fields["ipaddr2"]=$row2["ipaddr"];

   $row2 = $result2->FetchRow();
   $fields["hname3"]=$row2["hname"];
   $fields["ipaddr3"]=$row2["ipaddr"];

   $cnt=3;
   while($row2 = $result2->FetchRow()) {
      $fields["hname$cnt"]=$row2["hname"];
      $fields["ipaddr$cnt"]=$row2["ipaddr"];
      $cnt++;
   }

   $rep = new myTemplate;
   if ($rep->get("../templates/$filename") == FALSE)
      return FALSE;
   $swip=$rep->process($fields);

   return $swip;
}

?>
