<?php

// IPplan v4.25
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
//include('../adodb/adodb-errorhandler.inc.php');
require_once("/usr/lib64/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

require_once("../class.templib.php");

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$grps=$auth->authenticate();

// set language
isset($_COOKIE["ipplanNoAuth"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Results of your search");
newhtml($p);
$w=myheading($p, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
list($baseindex, $block, $showactive, $showdns, $action) = myRegister("I:baseindex I:block I:showactive I:showdns S:action");
list($userfld) = myRegister("A:userfld");  // from modifyipform - need to add rest flds
list($hname) = myRegister("S:hname");  // from modifyipformmul - need to add rest flds
list($user, $location, $descrip, $telno) = myRegister("S:user S:location S:descrip S:telno");

$formerror="";
// $ip can be array or string or undefined!
if (!isset($ip)) $ip=0; 
if (is_array($ip)) {
    foreach($ip as $key => $value) {
        $ip[$key]=floor($value);
    }
}
else {
   $ip=floor($ip);
}

if (!$_GET and !$_POST) {
   myError($w,$p, my_("You cannot reload or bookmark this page!"));
}

$ds=new IPplanDbf() or myError($w,$p, "Could not connect to database");

// script gets called back from modifyipform script so that user does
// not need to press back button
if ($_POST) {
    if ($grp=$ds->GetBaseGrp($baseindex)) {
        if (in_array($grp, $grps) or 
                $ds->TestCustomerGrp($baseindex, $_SERVER[AUTH_VAR])) {

            if ($md5str!=$ds->GetMD5($ip, $baseindex))
                myError($w,$p,my_("Another user modified the information before you saved - restart"));

            $ds->DbfTransactionStart();

            // additional information will arrive as assoc array called template
            // this is serialized into the info blob field of the database

            // need to start class and verify data before inserting

            if ($action=="delete") {

                // bad code - needs cleanup
                if (is_array($ip)) {
                    foreach($ip as $iptemp) {
                        // remove all attached files
                        $result=&$ds->ds->Execute("SELECT infobin
                                FROM ipaddradd
                                WHERE ipaddr=$iptemp AND baseindex=$baseindex");

                        $rowadd = $result->FetchRow();
                        $files=unserialize($rowadd["infobin"]);
                        // if dbf field is empty, unserialize returns FALSE
                        if ($files!=FALSE) {
                            foreach($files as $key => $value) {
                                @unlink(UPLOADDIRECTORY."/".($files[$key]["tmp_name"]));
                            }
                        }
                        $ds->DeleteIP($iptemp, $baseindex);
                        $ds->AuditLog(array("event"=>132, "action"=>"delete ip details", 
                        "ip"=>inet_ntoa($iptemp), "user"=>$_SERVER[AUTH_VAR], "baseindex"=>$baseindex));

                    }
                }
                else {
                    // remove all attached files
                    $result=&$ds->ds->Execute("SELECT infobin
                            FROM ipaddradd
                            WHERE ipaddr=$ip AND baseindex=$baseindex");

                    $rowadd = $result->FetchRow();
                    $files=unserialize((string)$rowadd["infobin"]);
                    // if dbf field is empty, unserialize returns FALSE
                    if ($files!=FALSE) {
                        foreach($files as $key => $value) {
                            @unlink(UPLOADDIRECTORY."/".($files[$key]["tmp_name"]));
                        }
                    }
                    $ds->DeleteIP($ip, $baseindex);
                    $ds->AuditLog(array("event"=>132, "action"=>"delete ip details", "ip"=>inet_ntoa($ip),
                    "user"=>$_SERVER[AUTH_VAR], "baseindex"=>$baseindex));

                }

                $ds->DbfTransactionEnd();
                insert($w,text(my_("IP address records deleted")));

            }
            else {
                /* too much overhead to check domain records - abandoned
                // check if there are A records for this customers domains?
                //
                // dont have cust available!
                if (!empty($hname)) {
                    $result = &$ds->ds->Execute("SELECT ip_hostname 
                            FROM fwdzonerec 
                            WHERE customer=$cust AND
                            recordtype=".$ds->ds->qstr("A")." AND 
                            ip_hostname=".$ds->ds->qstr(inet_ntoa($ip)));

                    $recs=$result->PO_RecordCount("fwdzonerec", "customer=$cust AND
                            recordtype=".$ds->ds->qstr("A")." AND 
                            ip_hostname=".$ds->ds->qstr(inet_ntoa($iphostname)));
                    if($recs > 0) {
                        echo "got some recs to update!";
                    }
                }
                */
                
                $err=FALSE;
                // if a specific network template exists, use that, else use generic template
                if (is_readable(dirname($_SERVER['SCRIPT_FILENAME'])."/iptemplate-network.xml") and !TestBaseAddr($ip, $subnetsize)) {
                    $template=new IPplanIPTemplate(dirname($_SERVER['SCRIPT_FILENAME'])."/iptemplate-network.xml");
                }
                else {
                    $template=new IPplanIPTemplate(dirname($_SERVER['SCRIPT_FILENAME'])."/iptemplate.xml");
                }
                // info field passed to ModifyIP must be "" if record is
                // to be deleted from ipaddradd table automatically to
                // conserve space - NB!
                $info="";
                if ($template->is_error() == FALSE) {
                    // PROBLEM HERE: if template create suddenly returns error (template file
                    // permissions, xml error etc), then each submit thereafter will erase
                    // previous contents - this is not good
                    $template->Merge($userfld);
                    $err=$template->Verify($w);

                    if ($template->is_blank() == FALSE) {
                        $info=$template->encode();
                    }
                }

                // verify template and insert data into tables - only insert if
                // template verifies ok
                if (!empty($hname)) {
                    if (!preg_match('/^(([\w][\w\-\.]*)\.)?([\w][\w\-]+)(\.([\w][\w\.]*))?$/', $hname)) {

                        $formerror .= sprintf(my_("Invalid hostname: %s %s"), inet_ntoa($ip), 
                                        $hname)."\n";
                    }
                }
                // is an address linked to another address - used for NAT?
                if (!empty($lnk)) {
                    if (!testIP($lnk)) {
                        // substr required to strip space added with each submit if user is empty
                        // and also to ensure field does not overflow 80 characters
                        $user = substr(trim("LNK$lnk $user"), 0, 79);
                    }
                    else {
                        $formerror .= sprintf(my_("Invalid link address: %s"), $lnk)."\n";

                    }
                }

                if ($err==FALSE and $ds->ModifyIP($ip, $baseindex, $user, $location, 
                            $telno, $descrip, $hname, $info) == 0) {
                    $ds->DbfTransactionEnd();
                    insert($w,textbr(my_("IP address details modified")));
                }
                else {
                    $formerror .= my_("IP address details could not be modified")."\n";
                }
            }
        }
        else {
            $formerror .= my_("You are not the owner of the subnet")."\n";
        }
    }
    else {
        $formerror .= my_("Could not find the owner of the subnet - subnet possibly deleted by another user")."\n";
    }
}

myError($w,$p, $formerror, FALSE);
    
// get info from base table
$result=$ds->GetBaseFromIndex($baseindex);

$row = $result->FetchRow();
$maxcnt=$row["subnetsize"];
$baseaddr=$row["baseaddr"];
$cust=$row["customer"];

// sanity check if MAXTABLESIZE in config.php is modified on the fly
// and person has maybe bookmarked paged
if ($baseaddr+$block*MAXTABLESIZE >= $baseaddr+$maxcnt) {
   myError($w,$p, my_("This page was bookmarked and contains invalid information which cannot be displayed anymore - restart from main menu"));
}

insert($w,block("<h3>"));
insert($w,text(my_("Subnet:")." ".
                  inet_ntoa($baseaddr)." ".my_("Mask:")." ".
                  inet_ntoa(inet_aton(ALLNETS)+1 -
                    $maxcnt)."/".inet_bits($maxcnt)));
insert($w,textbr());
insert($w,text(my_("Description:")." ".$row["descrip"]));
insert($w,block("</h3>"));

if ($showactive) {
   // increase time limit for scans - will have no effect if safe mode is on
   @set_time_limit(90);
}
else {
   insert($w,anchor($_SERVER["PHP_SELF"]."?baseindex=".$baseindex."&showactive=1&block=".$block,
                    my_("Show used addresses")));
 
   insert($w,textbr(my_(" This can take a while as each address is polled.  Green is active, Red is inactive")));
}
if ($showdns) {
   // increase time limit for dns query - will have no effect in safe mode is on
   @set_time_limit(90);
}
else {
   insert($w,anchor($_SERVER["PHP_SELF"]."?baseindex=".$baseindex."&showdns=1&block=".$block,
                    my_("Show DNS changes")));
 
   insert($w,textbr(my_(" Show descriptions that do not match DNS reverse entries. Red is new DNS value")));
}

insert($w,block("<p>"));

// only display stats for networks with more than 1 host
if ($maxcnt > 1) {
    insert($w,$tbig = table(array("cols"=>"3")));
    insert($tbig,$c = cell());
    insert($c,textbr(my_("Select multiple addresses to do a bulk change")));
    insert($c,text(my_("Ideal for reserving DHCP ranges")));

    // start form for drop down list
    insert($c, $f = form(array("name"=>"MODIFYMULTIPLE",
                    "method"=>"post",
                    "action"=>"modifyipformmul.php")));

    // build "option select" list
    $lst=array();
    for ($i=$block*MAXTABLESIZE; $i < $block*MAXTABLESIZE+MAXTABLESIZE; $i++) {
        if ($i > 0 and $i < $maxcnt-1) {
            $col=$row["baseaddr"]+$i;
            $lst["$col"]=inet_ntoa($row["baseaddr"]+$i);
        }
    }
    insert($f,selectbox($lst,
                array("name"=>"ip[]", 
                    "multiple size"=>"5")));

    insert($f,hidden(array("name"=>"baseindex",
                    "value"=>"$baseindex")));
    insert($f,hidden(array("name"=>"block",
                    "value"=>"$block")));

    insert($f,generic("br"));
    insert($f,submit(array("value"=>my_("Submit"))));
    insert($f,freset(array("value"=>my_("Clear"))));

    // start form for "Use next address" button
    insert($c,text("| "));
    insert($c,anchor("modifyipform.php?baseindex=$baseindex&baseaddr=$baseaddr&block=$block",
            my_("Use next available address")));
    insert($c,text(" | "));
    insert($c,anchor("modifyipform.php?baseindex=$baseindex&baseaddr=$baseaddr&block=$block&probe=1",
            my_("Use next available address and probe network if active")));
    insert($c,textbr(" |"));

    insert($tbig,$c = cell());
    // create stats cell for later use
    insert($tbig,$cstats = cell(array("valign"=>"top")));
}

// get detail from ipaddr table - could be nothing!
$result=$ds->GetSubnetDetails($baseindex);
// emulate for databases that do not have RecordCount
$recs=$result->PO_RecordCount("ipaddr", "baseindex=$baseindex");

// create a table
insert($w,$t = table(array("cols"=>"8",
                           "class"=>"outputtable")));
// draw heading
setdefault("cell",array("class"=>"heading"));
insert($t,$ck1 = cell());
// display preceding cell later
insert($t,$c = cell());
insert($c,text(my_("User")));
insert($t,$c = cell());
insert($c,text(my_("Location")));
insert($t,$c = cell());
insert($c,text(my_("Device description")));
insert($t,$c = cell());
insert($c,text(my_("Telephone Number")));
insert($t,$c = cell());
insert($c,textbr(my_("P")));
insert($c,textbr(my_("o")));
insert($c,text(my_("l")));
insert($t,$c = cell());
insert($c,text(my_("Last modified")));
insert($t,$ck2 = cell());
insert($ck2,text(my_("Changed by")));

 
// fastforward till first record if not first block of data
while ($row = $result->FetchRow() and 
       $row["ipaddr"] < $baseaddr+($block*MAXTABLESIZE));

$res=0;
$ipscan=array();
if ($showactive and NMAP != "") {
    $nmapstart=inet_ntoa($baseaddr+($block*MAXTABLESIZE));
    $nmapend=inet_ntoa($baseaddr+($block*MAXTABLESIZE)+MAXTABLESIZE-1);
    $ipscan = NmapScan(NmapRange($nmapstart, $nmapend));
    // nmap had error due to safe mode?
    if ($ipscan == FALSE) {
        $showactive=0;
    }
}

$pollcnt=array("d"=>0, "w"=>0, "m"=>0, "y"=>0);
for ($i=$block*MAXTABLESIZE; $i < $block*MAXTABLESIZE+MAXTABLESIZE; $i++) {
   setdefault("cell",array("class"=>color_flip_flop()));
   
   $polled=0;
   // did user select to scan if address is active?
   if ($showactive) {
       if (NMAP=="") {
           if (ScanHost(inet_ntoa($baseaddr+$i))) {
               insert($t,$c = cell(array("class"=>"greencell")));
               // should be transaction here!
               $ds->UpdateIPPoll($baseindex, $baseaddr+$i);
               $polled=1;
           }
           else {
               insert($t,$c = cell(array("class"=>"redcell")));
           }
       }
       else {
           if (isset($ipscan[inet_ntoa($baseaddr+$i)])) {
               insert($t,$c = cell(array("class"=>"greencell")));
               // should be transaction here!
               $ds->UpdateIPPoll($baseindex, $baseaddr+$i);
               $polled=1;
           }
           else {
               insert($t,$c = cell(array("class"=>"redcell")));
           }
       }
   }
   else {
      insert($t,$c = cell());
   }

   // strange! brackets must be there in php 4.0.4p1, else code wrong!
   insert($c,anchor("modifyipform.php?ip=".($baseaddr+$i).
                    "&baseindex=".$baseindex."&block=".$block,
                    inet_ntoa($baseaddr+$i)));
 
   insert($t,$c = cell());
   // network address
   if ($i == 0) {
      insert($c,text(my_("Reserved - network address"), 
                array("color"=>"#FF0000")));
      insert($c,textbr());
   }
   // broadcast address
   else if ($i == $maxcnt-1) {
      insert($c,text(my_("Reserved - broadcast address"), 
                array("color"=>"#FF0000")));
      insert($c,textbr());
   }
   // display only rows that exist in database
   if ($row["ipaddr"] == $baseaddr+$i) {
      // count reserved addresses
      if ($i == 0 or $i == $maxcnt-1)
         $res++;

      // check if userinf field has an encoded linked address in format of LNKx.x.x.x
      // where x.x.x.x is an ip address
      $lnk="";
      $userinf=$row["userinf"];
      if (preg_match("/^LNK[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}/", $userinf)) {
          list($lnk, $userinf) = preg_split("/[\s]+/", $userinf, 2);
          $lnk=substr($lnk, 3);
      }
      insert($c,textbr($userinf));
      if (!empty($lnk)) {
          insert($c,block("<small><i>"));
          insert($c,anchor("displaybase.php?ipaddr=$lnk&cust=$cust&searchin=1",
                      my_(sprintf("Follow link to %s", $lnk))));
          insert($c,block("</i></small>"));
      }

      insert($t,$c = cell());
      insert($c,text($row["location"]));
      insert($t,$c = cell());
      insert($c,text($row["descrip"]));
      if ($showdns) {
         $dnsdescrip=gethostbyaddr(inet_ntoa($baseaddr+$i));
         if ($dnsdescrip != inet_ntoa($baseaddr+$i) and 
             $dnsdescrip != $row["hname"]) {
            if (!empty($row["hname"])) {
               insert($c,textbr());
            }
            insert($c,text($dnsdescrip, array("color"=>"#FF0000")));
         }
      }
      if (!empty($row["hname"])) {
         insert($c,textbr());
         insert($c,block("<small><i>"));
         insert($c,text($row["hname"]));
         insert($c,block("</i></small>"));
      }
      insert($t,$c = cell());
      insert($c,text($row["telno"]));

      // display info about when last device was polled
      insert($t,$c = cell());
      if ($polled or $result->UnixDate($row["lastpol"]) > time()-(3600*24)) {
        insert($c,text("D"));
        $pollcnt["d"]++;
      }
      else if ($result->UnixDate($row["lastpol"]) > time()-(3600*24*7)) {
        insert($c,text("W"));
        $pollcnt["w"]++;
      }
      else if ($result->UnixDate($row["lastpol"]) > time()-(3600*24*30)) {
        insert($c,text("M"));
        $pollcnt["m"]++;
      }
      else if ($result->UnixDate($row["lastpol"]) > time()-(3600*24*365)) {
        insert($c,text("Y"));
        $pollcnt["y"]++;
      }
      
      insert($t,$c = cell());
      insert($c,block("<small>"));
      insert($c,block($result->UserTimeStamp($row["lastmod"], "M d Y H:i:s")));
      insert($c,block("</small>"));
      insert($t,$c = cell());
      insert($c,text($row["userid"]));

      $row = $result->FetchRow();
   }
   else {
      insert($t,$c = cell());
      insert($t,$c = cell());
      if ($showdns) {
         $dnsdescrip=gethostbyaddr(inet_ntoa($baseaddr+$i));
         if ($dnsdescrip!=inet_ntoa($baseaddr+$i)) {
            insert($c,text($dnsdescrip, array("color"=>"#FF0000")));
         }
      }
      insert($t,$c = cell());
      insert($t,$c = cell());
      if ($polled) {
        insert($c,text("D"));
        $pollcnt["d"]++;
      }
      insert($t,$c = cell());
      insert($t,$c = cell());
   }

   // exit loop when subnet is done - protects against MAXTABLESIZE
   // not being a power of two (eg 64, 128 etc)
   if ($baseaddr+$i >= $baseaddr+$maxcnt-1) {
      break;
   }
}

insert($w,block("<p>"));

// only display stats for networks with more than 1 host
if ($maxcnt > 1) {
    // display stats
    $res=2-$res;
    insert($cstats,textb(my_("Subnet Summary")));
    insert($cstats,block("<p>"));
    insert($cstats,textbr(my_("Total addresses:")." ".$maxcnt));
    insert($cstats,textbr(my_("Used addresses:")." ".($recs+$res)));
    insert($cstats,textbr(my_("Free addresses:")." ".($maxcnt-$recs-$res)));
    insert($cstats,textbr(my_("Active polled (D/W/M/Y):")." ".
        sprintf("%d/%d/%d/%d", $pollcnt["d"],$pollcnt["w"],$pollcnt["m"],$pollcnt["y"])));
    insert($cstats,textbr(my_("Utilization:")." ".(round(($recs+$res)/$maxcnt*100,2))."%"));
    insert($cstats,textbr(my_("Efficiency:")." ".(round(($recs)/$maxcnt*100,2))."%"));
}

// display various blocks of subnet
$cnt=0;
$vars="";
for ($i=$baseaddr; $i<$baseaddr+$maxcnt; $i=$i+MAXTABLESIZE) {
    if ($block != $cnt) {
       if ($i+MAXTABLESIZE >= $baseaddr+$maxcnt-1) {
          $vars=$_SERVER["PHP_SELF"]."?baseindex=".$baseindex."&block=".$cnt."&showactive=".$showactive;
          insert($w,anchor($vars,
                           inet_ntoa($i)." - ".inet_ntoa($baseaddr+$maxcnt-1)));
       }
       else {
          $vars=$_SERVER["PHP_SELF"]."?baseindex=".$baseindex."&block=".$cnt."&showactive=".$showactive;
          insert($w,anchor($vars,
                           inet_ntoa($i)." - ".inet_ntoa($i+MAXTABLESIZE-1)));
       }

    insert($w,textbr());
    }
    $cnt++;
}
if ($block > 0) {
    $vars=$_SERVER["PHP_SELF"]."?baseindex=".$baseindex."&block=".($block-1)."&showactive=".$showactive;
    insert($ck1,anchor($vars, "<<"));
}
if ($cnt-1 != $block) {
    $vars=$_SERVER["PHP_SELF"]."?baseindex=".$baseindex."&block=".($block+1)."&showactive=".$showactive;
    insert($ck2,anchor($vars, ">>"));
}
insert($ck1,textb(my_("IP address")));

$result->Close();
printhtml($p);

?>
